#include "ad_deriv.h"

void  ad_func(DERIV_TYPE [], DERIV_TYPE [], DERIV_TYPE);

int  main() {
  DERIV_TYPE x[3], y[3], z;
  int i, j, k;
  double grad[6], hess[6][6];

  /* Set values for independent variables */
  DERIV_val(x[0]) = ...;
    :

  /* Initialize the derivatives of the independent variables */
  ad_AD_Init(); 
  ad_AD_SetIndepArray(x, 3);
  ad_AD_SetIndepArray(y, 3);
  ad_AD_SetIndepDone();

  /* Compute the derivatives */
  ad_func(x, y, z);

  /* Extract derivative values */
  ad_AD_ExtractGrad(z, grad);
  ad_AD_ExtractHess(z, hess);

}
